----------------------------------------------------------------------------------
--  
--        divide.vhd        A(Q15)  B(Q15) = Q(Q15)   ilatency=18j
--  
--        (c)2011/06/10  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--
--
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                       88  out of   1792     4%  
-- Number of Slice Flip Flops:             71  out of   3584     1%  
-- Number of 4 input LUTs:                139  out of   3584     3%  
-- Number of IOs:                          51
-- Number of bonded IOBs:                  51  out of     68    75%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 6.197ns (Maximum Frequency: 161.368MHz)
--   Minimum input arrival time before clock: 6.079ns
--   Maximum output required time after clock: 5.531ns
--   Maximum combinational path delay: No path found
--
--
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity divide is 
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- ̓f[^L
    A       : in  std_logic_vector( 15 downto 0 ); -- 폜@dividend
    B       : in  std_logic_vector( 15 downto 0 ); -- @divisor
    Q       : out std_logic_vector( 15 downto 0 ); -- @quotient 
    OD      : out std_logic                        -- o̓f[^L
  );
end divide;


------------------------------------------------------------------------------
architecture RTL of divide is
  
  signal SIGN   : std_logic; --
  signal A_ABS  : std_logic_vector( 15 downto 0 ); --
  signal B_ABS  : std_logic_vector( 15 downto 0 ); --
  signal AQ     : std_logic_vector( 31 downto 0 ); --
  signal B0     : std_logic_vector( 15 downto 0 ); --
  signal AB     : std_logic_vector( 15 downto 0 ); --
  signal N      : std_logic_vector( 4 downto 0 ); -- [v
  
  
begin
  
  A_ABS <= A when( A(15) = '0' ) else (not A) + 1;
  B_ABS <= B when( B(15) = '0' ) else (not B) + 1;
  
  AB <= AQ(31 downto 16) - B0;
  
  ------------------------------------------------------------------
  --    Z
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      
      if( ND='1' ) then
        SIGN <= A(15) xor B(15);        -- ̕
        AQ   <= "0" & A_ABS(15 downto 0) & "000000000000000";
        B0   <= B_ABS;
        N    <= (others => '0');
        
      elsif( N(4)='0' ) then            -- 16JԂ
        if( AB(15) = '0' ) then         -- A >= B
          AQ <= AB( 14 downto 0 ) & AQ(15 downto 0 ) & "1";
        else                            -- A < B
          AQ <= AQ( 30 downto 0 ) & "0";
        end if;
        N <= N+1;
        
      else
        if( N(0)='0' ) then
          if( SIGN = '0' ) then
            Q  <= AQ( 15 downto 0);
          else
            Q  <= (not AQ( 15 downto 0)) + 1;
          end if;
          OD <= '1';
          N  <= N+1;
        else
          OD <= '0';
        end if;
        
      end if;
      
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

