----------------------------------------------------------------------------------
--  
--        fm_det.vhd        FMg( ARCTAN(Q/I)ČvZ )
--  
--        (c)2011/06/06  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
--  ƓIp͂߂B
--  
--  
----------------------------------------------------------------------------------
--  
--  Ίp arg = arctan(Q/I) ƁA
--  
--  freq = ( Q * I - I * Q )/( I * I + Q * Q )
--  
--  Q = Q - Q * Z-1
--  I = I - I * Z-1
--  
--  ƎgB
--  
----------------------------------------------------------------------------------
--  
--U(I^2+Q^2)ł̊Z
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                      231  out of   1792    12%  
-- Number of Slice Flip Flops:            268  out of   3584     7%  
-- Number of 4 input LUTs:                292  out of   3584     8%  
-- Number of IOs:                          52
-- Number of bonded IOBs:                  52  out of     68    76%  
-- Number of MULT18X18SIOs:                 1  out of     16     6%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 6.750ns (Maximum Frequency: 148.148MHz)
--   Minimum input arrival time before clock: 5.332ns
--   Maximum output required time after clock: 5.531ns
--   Maximum combinational path delay: No path found
--
--
--U(I^2+Q^2)ł̊ZȂ@Rc
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                      117  out of   1792     6%  
-- Number of Slice Flip Flops:            148  out of   3584     4%  
-- Number of 4 input LUTs:                 90  out of   3584     2%  
-- Number of IOs:                          52
-- Number of bonded IOBs:                  52  out of     68    76%  
-- Number of MULT18X18SIOs:                 1  out of     16     6%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 6.694ns (Maximum Frequency: 149.388MHz)
--   Minimum input arrival time before clock: 4.454ns
--   Maximum output required time after clock: 5.558ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

Library UNISIM;
use UNISIM.vcomponents.all;

------------------------------------------------------------------------------
entity fm_det is 
  port (
    RESET   : in  std_logic;                       -- 
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 15 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 15 downto 0 ); -- Q M
    DET_OUT : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    OD      : out std_logic                        -- o̓f[^L
  );
end fm_det;


------------------------------------------------------------------------------
architecture RTL of fm_det is
  
  signal I      : std_logic_vector( 15 downto 0 ); -- 
  signal Q      : std_logic_vector( 15 downto 0 ); -- 
  signal IZ     : std_logic_vector( 15 downto 0 ); -- 
  signal QZ     : std_logic_vector( 15 downto 0 ); -- 
  signal IQZ    : std_logic_vector( 15 downto 0 ); -- 
  signal QIZ    : std_logic_vector( 15 downto 0 ); -- 
  signal MULOUT : std_logic_vector( 35 downto 0 ); -- 
  signal MULAIN : std_logic_vector( 17 downto 0 ); -- 
  signal MULBIN : std_logic_vector( 17 downto 0 ); -- 
  signal I2     : std_logic_vector( 15 downto 0 ); -- I^2
  signal Q2     : std_logic_vector( 15 downto 0 ); -- Q^2
  signal A      : std_logic_vector( 15 downto 0 ); -- 
  signal B      : std_logic_vector( 15 downto 0 ); -- 
  signal ND_DIV : std_logic;                       -- 
  
  signal CNT    : std_logic_vector(  3 downto 0 ); -- 
  
  component divide
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- ̓f[^L
    A       : in  std_logic_vector( 15 downto 0 ); -- 폜@dividend
    B       : in  std_logic_vector( 15 downto 0 ); -- @divisor
    Q       : out std_logic_vector( 15 downto 0 ); -- @quotient 
    OD      : out std_logic                        -- o̓f[^L
  );
  end component;
  
  
begin
  
  U0 : MULT18X18
  port map (
    P   => MULOUT,  -- 36-bit multiplier output
    A   => MULAIN,  -- 
    B   => MULBIN   -- 
  );
  
  
  u1 : divide
  port map (
    CLK => CLK,     -- 
    ND  => ND_DIV,  -- ̓f[^L
    A   => A,       -- 폜@dividend
    B   => B,       -- @divisor
    Q   => DET_OUT, -- @quotient 
    OD  => OD       -- o̓f[^L
  );
  
  
  ------------------------------------------------------------------
  --    Ίpi arctan(Q/I) jg𓾂
  --    freq = ( Q * I - I * Q )/( I * I + Q * Q )
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET = '1' ) then
      CNT   <= (others => '0');
      I     <= (others => '0');
      Q     <= (others => '0');
      MULAIN  <= (others => '0');
      MULBIN  <= (others => '0');
    elsif( rising_edge(CLK) ) then
      if( CNT = "000" ) then
        if( ND='1' ) then                       -- f[^
          IZ <= I;
          QZ <= Q;
          I  <= I_IN;
          Q  <= Q_IN;
          CNT <= CNT + 1;
        end if;
      else
        if( CNT = "0001" ) then
          MULAIN(17 downto 2) <= Q;           --
          MULBIN(17 downto 2) <= IZ;          -- I*(Z-1)
        elsif( CNT = "0010" ) then
          QIZ   <= MULOUT(34 downto 19);      -- 
          MULAIN(17 downto 2) <= I;           -- 
          MULBIN(17 downto 2) <= QZ;          -- Q*(Z-1)
        elsif( CNT = "0011" ) then
          IQZ   <= MULOUT(34 downto 19);      -- 
        elsif( CNT = "0111" ) then
          MULAIN(17 downto 2) <= I;           -- I
          MULBIN(17 downto 2) <= I;           -- I
        elsif( CNT = "1000" ) then
          I2  <= MULOUT(34 downto 19);        -- I^2
          MULAIN(17 downto 2) <= Q;           -- Q
          MULBIN(17 downto 2) <= Q;           -- Q
        elsif( CNT = "1001" ) then
          Q2  <= MULOUT(34 downto 19);        -- I^2
        elsif( CNT = "1010" ) then
          A  <= QIZ - IQZ;                    -- Q * IZ - I * QZ
          B  <= I2 + Q2;                      -- I^2 + Q^2
          ND_DIV <= '1';                      -- ZJn
        else
          ND_DIV <= '0';                      -- 
        end if;
        CNT <= CNT + 1;
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

